﻿// importeren van namespaces
using System;

//namespace definitie
namespace oop
{
    //klasse definitie van oop.Persoon
    public class Persoon
    {
        //private field
        private DateTime gebDatum;
        private string naam;

        //read-write property
        public String Naam
        {
            get { return naam; }
            set { naam = value; }
        }
        //read-only property
        public DateTime GebDatum
        {
            get { return gebDatum; }
        }

        // read-only property
        public int Leeftijd
        {
            get { return BerekenLeeftijd(gebDatum); }
        }

        public void SetGebDatum(DateTime dt)
        {
            gebDatum = dt;
        }
        //method overloading: zelfde naam, verschillende argumenten
        public void SetGebDatum(String dt)
        {
            gebDatum = DateTime.Parse(dt);
        }

        //methode kan overschreven worden in afgeleide klasse
        public virtual int BerekenLeeftijd(DateTime gebDatum)
        {
            DateTime vandaag = DateTime.Today;
            int leeftijd = vandaag.Year - gebDatum.Year;
            DateTime verjaardag = new DateTime(vandaag.Year, gebDatum.Month, gebDatum.Day);
            if (verjaardag > vandaag) leeftijd = leeftijd - 1;
            return leeftijd;
        }
        
        //Constructor
        //
        //public Persoon(String naam, DateTime gebDatum)
        //{
        //    this.Naam = naam;
        //    this.gebDatum = gebDatum;
        //}

    }
    public class LeeftijdLeugenaar : Persoon
    {
        //public LeeftijdLeugenaar(String naam, DateTime gebDatum)
        //    : base(naam, gebDatum)
        //{
        //}
        public override int BerekenLeeftijd(DateTime gebDatum)
        {
            return base.BerekenLeeftijd(gebDatum) - 1;
        }
    }
}
